import o from"path";import{URL as r}from"url";import t from"yargs";import{hideBin as e}from"yargs/helpers";import i from"os";import n from"fs";import l from"yamljs";import{execSync as s}from"child_process";function a(o){return o?o[0].toUpperCase()+o.substring(1).toLowerCase():void 0}const f=/^0x([a-fA-F0-9]{6}|[a-fA-F0-9]{3})$/,d=/^#([a-fA-F0-9]{6}|[a-fA-F0-9]{3})$/;function c(o){o=o.trim();if(!/^([a-fA-F0-9]{6}|[a-fA-F0-9]{3})$/.test(o))throw new Error("Color code provided, is neither in 3 letter format nor in 6 letter format..");if(3===o.length){let r="";for(let t=0;t<=2;t++)r+=o.charAt(t)+o.charAt(t);return r}return o}function u(o){if(o&&(!o||""!==o.trim())){if(o=o.trim(),f.test(o))return"#"+c(o.substring(2));if(d.test(o))return"#"+c(o.substring(1));throw new Error("Color code is not provided in hex(0x) or hash(#) format..")}}function v(o){if(o&&(!o||""!==o.trim())){if(o=o.trim(),d.test(o))return"0x"+c(o.substring(1));if(f.test(o))return"0x"+c(o.substring(2));throw new Error("Color code is not provided in hex(0x) or hash(#) format..")}}function y(o={}){var r,i,n,l,s,f,d,c,u,y,m,p,h,g;const b="fontsize",w="bgcolor",x="fgcolor",k="selcolor",$="cursor",E="opacity",_=16,A="#111122",F="#ccccff",C="#111122",P="Block",z=1;return t(e(process.argv)).options({s:{type:"number"},b:{type:"string"},c:{type:"string"},t:{type:"string"},y:{type:"string"},o:{type:"number"}}).usage("Usage: node dist/$0 [options]=[values]\n\nThe options may/may not provided in the CLI. If they are not provided, either the previously set config is used or the defaults are set.").help("h").version("1.1.2").alias("s",b).alias("b",w).alias("c",x).alias("t",k).alias("y",$).alias("o",E).alias("h","help").alias("v","version").default(b,null!==(i=null===(r=null==o?void 0:o.font)||void 0===r?void 0:r.size)&&void 0!==i?i:_).default(w,null!==(s=null===(l=null===(n=null==o?void 0:o.colors)||void 0===n?void 0:n.primary)||void 0===l?void 0:l.background)&&void 0!==s?s:A).default(x,null!==(c=null===(d=null===(f=null==o?void 0:o.colors)||void 0===f?void 0:f.primary)||void 0===d?void 0:d.foreground)&&void 0!==c?c:F).default(k,null!==(m=null===(y=null===(u=null==o?void 0:o.colors)||void 0===u?void 0:u.selection)||void 0===y?void 0:y.text)&&void 0!==m?m:C).default($,null!==(h=null===(p=null==o?void 0:o.cursor)||void 0===p?void 0:p.style)&&void 0!==h?h:P).default(E,null!==(g=null==o?void 0:o.background_opacity)&&void 0!==g?g:z).nargs({[b]:1,[w]:1,[x]:1,[k]:1,[$]:1,[E]:1}).describe(b,`Takes font size to be set in alacritty\t[default=${_}]`).describe(w,`Takes primary background color in #ffffff or #fff or 0xfff or 0xffffff format\t[default=${A}]`).describe(x,`Takes primary foreground color in #ffffff or #fff or 0xfff or 0xffffff format\t[default=${F}]`).describe(k,`Takes text color (when the area is selected) in #ffffff or #fff or 0xfff or 0xffffff format\t[default=${C}]`).describe($,`Takes cursor style that can be Block or Underline or Beam\t[default=${P}]`).describe(E,`Takes background opacity which is between 0.0 (transparent) and 1.0 (opaque)\t[default=${z}]`).check((o=>{if(o.s&&(o.s<=0||o.s>40))throw new Error(`Wrong Arguments: Provided font size ${o.s} should be within the range of display: 0.1 to 40.0`);if(o.b&&void 0===v(""+o.b))throw new Error(`Wrong Arguments: Provided background color ${o.b} should be in hash or hex format`);if(o.c&&void 0===v(""+o.c))throw new Error(`Wrong Arguments: Provided font color ${o.c} should be in hash or hex format`);if(o.t&&void 0===v(""+o.t))throw new Error(`Wrong Arguments: Provided selection text color ${o.t} should be in hash or hex format`);if(o.y&&!["Block","Underline","Beam"].includes(a(""+o.y)))throw new Error(`Wrong Arguments: Provided cursor style ${o.y} should be in one of the 3 styles`);if(o.o&&(o.o<0||o.o>1))throw new Error(`Wrong Arguments: Provided background opacity ${o.o} should be between 0.0 and 1.0`);return!0})).argv}function m(o){if("string"==typeof o){if(!o||o&&""===o.trim())return;if(o=o.trim(),f.test(o))return"#"+c(o.substring(2));if(d.test(o))return"#"+c(o.substring(1));throw new Error("Color code is not provided in hex(0x) or hash(#) format..")}if("number"==typeof o){return"#"+c(o.toString(16))}}function p(o){if("string"==typeof o){if(!o||o&&""===o.trim())return;if(o=o.trim(),d.test(o))return"0x"+c(o.substring(1));if(f.test(o))return"0x"+c(o.substring(2));throw new Error("Color code is not provided in hex(0x) or hash(#) format..")}if("number"==typeof o){return"0x"+c(o.toString(16))}}function h(){if("Windows_NT"===i.type())throw new Error("Platform win32 not supported by our app");try{s("which alacritty")}catch(o){throw new Error("Package Not Installed: alacritty is not installed in your system or it's path is not set in your PATH variable, so you cannot use our library..")}const r=o.join(i.homedir(),".config/alacritty/alacritty.yml");return n.existsSync(r)||(n.mkdirSync(o.dirname(r),{recursive:!0}),n.writeFileSync(r,"")),r}function g(o){try{return l.load(o)}catch(o){throw new Error("Cannot load original alacritty config file from the path provided..")}}function b(r,t){const e=o.join(t,"user_config_temp"),i=o.resolve(e,"alacritty.json");n.mkdirSync(e,{recursive:!0}),n.writeFileSync(i,JSON.stringify(r),"utf8");const l=`npx json2yaml '${i}' --save -d 8 && mv '${o.resolve(e,"alacritty.yaml")}' '${o.resolve(e,"alacritty.yml")}' && cp '${o.resolve(e,"alacritty.yml")}' '${t}' && rm -rf ${e}`;s(l),console.log("Please close and reopen all windows of alacritty if some effects were not applied..")}function w(o={},r,t){var e,i,n,l,s,f,d,c,u,y,m,p,h,g;let w=null!==(n=null===(i=null===(e=null==o?void 0:o.colors)||void 0===e?void 0:e.primary)||void 0===i?void 0:i.background)&&void 0!==n?n:"",x=null!==(f=null===(s=null===(l=null==o?void 0:o.colors)||void 0===l?void 0:l.primary)||void 0===s?void 0:s.foreground)&&void 0!==f?f:"",k=null!==(c=null===(d=null==o?void 0:o.font)||void 0===d?void 0:d.size)&&void 0!==c?c:void 0,$=null!==(m=null===(y=null===(u=null==o?void 0:o.colors)||void 0===u?void 0:u.selection)||void 0===y?void 0:y.text)&&void 0!==m?m:"",E=null!==(h=null===(p=null==o?void 0:o.cursor)||void 0===p?void 0:p.style)&&void 0!==h?h:"Block",_=null!==(g=null==o?void 0:o.background_opacity)&&void 0!==g?g:void 0,{primary_bgcolor:A=w,primary_fgcolor:F=x,fontsize:C=k,selection_fgcolor:P=$,cursor_style:z=E,background_opacity:B=_}=r;if(A=v(A),F=v(F),P=v(P),C<.1||C>40)throw new Error("Font size provided is not in the range 0.1 to 40.0");if(z&&!["Block","Underline","Beam"].includes(a(z)))throw new Error("Cursor style provided is not in one of the 3 accepted styles");if(B<0||B>1)throw new Error("Background opacity provided is not in the range 0.0 to 1.0");const S=Object.assign(Object.assign({},o),{font:{size:C},colors:{primary:{background:A,foreground:F},selection:{text:P}},cursor:{style:z},background_opacity:B});return b(S,t),S}var x;const k=new r(`file://${process.argv[1]}`);(null===(x=import.meta)||void 0===x?void 0:x.url)===k.toString()&&function(){let r="";try{r=h();let t=g(r);const e=o.dirname(r);let i=y(t);w(t,{fontsize:parseFloat(""+i.s),primary_bgcolor:i.b,primary_fgcolor:i.c,selection_fgcolor:i.t,cursor_style:i.y,background_opacity:parseFloat(""+i.o)},e)}catch(o){console.error(o)}}();export{h as configInit,c as convertShortToLongCode,u as convertToHash,v as convertToHex,w as editConfig,d as hash_color_regex,f as hex_color_regex,m as oldConvertToHash,p as oldConvertToHex,g as readOriginalConfig,y as takeArgumentInputs,b as writeToConfigFile};
